/**************************************************************************
***************************************************************************
---------------------------------------------------------------------------
*		L I N K 8 8 2 . D L L
---------------------------------------------------------------------------
*		Id:			LINK882.h, 05/05/2010, by hhosoglu
*		Compiler:	Microsoft Visual C++ .NET
*		Revision:	V1.00
---------------------------------------------------------------------------
*		This code is a part of the ddm library
*		Copyright (c) 2006-2011 ddm Software
---------------------------------------------------------------------------
V	1.00	05.05.2010	First release
V	1.01	04.01.2011	Extended timeouts
V	1.02	31.05.2011	Added DTR control function
V	1.03	09.06.2011	Added uninstall for Callback pointer for all int.
V	1.04	27.10.2011	Added sendCommBytes function
V	1.05	06.03.2012	Corrected Init_Comm Function to enable ports >9
V	1.06	09.03.2012	USB checks VID and PID
V	1.10	08.02.2012	Framework 4.0 support
V	1.11	03.04.2012	SERIO32 Removed delete statements
V	1.12	13.06.2012	ComThread added error recovery
***************************************************************************
**************************************************************************/
#ifndef __LINK882_H
#define __LINK882_H
/**************************************************************************
**************************************************************************/
#ifndef _MFC_VER
#include <afxwin.h>         // MFC core and standard components
#endif
/**************************************************************************
**************************************************************************/
#define DLL_VERSION				112
/**************************************************************************
* Callback Function
**************************************************************************/
typedef void (CALLBACK * COR_CALLBACK)(unsigned int addr, unsigned int status,unsigned char *data,unsigned int len);
typedef void (CALLBACK * BOOT_CALLBACK)(unsigned int percent);
typedef void (CALLBACK * FM_CALLBACK)(int status, unsigned long val);
/**************************************************************************
**************************************************************************/
#ifdef __cplusplus
extern "C" {
#endif
/**************************************************************************
* Comm Port related functions
**************************************************************************/
BOOL __stdcall initComm(int port,int baud,int timeout);
BYTE __stdcall sendCommBytes(unsigned char* data, unsigned int len);
BOOL __stdcall rtsControl(int rts);
BOOL __stdcall dtrControl(int dtr);
BOOL __stdcall killComm(void);
/**************************************************************************
* USB Functions
**************************************************************************/
unsigned char __stdcall usbHidConnect(unsigned char* name);
void __stdcall usbHidKill(void);
/**************************************************************************
* TCP and UDP Functions
**************************************************************************/
unsigned char __stdcall tcpConnect(char *add, unsigned int port);
unsigned char __stdcall tcpClose();
unsigned char __stdcall udpOpen(unsigned int port, char * dest_addr, int listen_only);
unsigned char __stdcall udpClose();
/**************************************************************************
* Common functions for all interfaces
**************************************************************************/
BOOL __stdcall setCallBackPointer( COR_CALLBACK lpEventCallbackFn );
BOOL __stdcall getDLLVersion(unsigned int *ver);
int __stdcall getDLLVersion2(void);
BYTE __stdcall sendCmd(unsigned char add, unsigned char cmd,unsigned char* snd,unsigned int len);  
/**************************************************************************
* Bootloader Functions
**************************************************************************/
BYTE __stdcall Boot882_ProgFirmware(LPCSTR hFile);
BYTE __stdcall Boot882_VerifyFirmware(LPCSTR hFile);
BYTE __stdcall Boot882_EraseFlash(void);
BYTE __stdcall Boot882_BlankCheck(void);
BYTE __stdcall Boot882_Program(DWORD offset, WORD length, BYTE* data);
BYTE __stdcall Boot882_UserCodeCheck(void);
BYTE __stdcall Boot882_ExeUserCode(void);
BYTE __stdcall Boot882_ExeBootCode(void);
BYTE __stdcall Boot882_ReadFlash(DWORD offset, WORD length, BYTE* data);
BYTE __stdcall Boot882_GetMode(void);
BYTE __stdcall Boot882_SignFirmware(void);
BYTE __stdcall Boot882_SetCallBackPointer(BOOT_CALLBACK lpEventCallbackFn);
BYTE __stdcall FM_SetCallBackPointer(FM_CALLBACK lpEventCallbackFn);
BYTE __stdcall Boot882_SetAddr(int a);
unsigned int __stdcall chksum_crc32 (unsigned char *block, unsigned int length);
/**************************************************************************
**************************************************************************/
#ifdef __cplusplus
}
#endif
/**************************************************************************
**************************************************************************/
#endif

